#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using dnp.DomainModeler;
using dnp.DomainModeler.Configuration;
using dnp.Framework.Reflection;
using MbUnit.Framework;

namespace dnp.DomainModeler.Test
{
    [TestFixture]
    public class BusinessKeyTest
    {
        private Domain _domain = null;

        [TestFixtureSetUp]
        public void Setup()
        {
            DomainModelDefinition def =
                Serializer.DeserializeFromResource<DomainModelDefinition>("ReferenceSchema-DomainDefinition.xml");
            _domain = new Domain(def);
        }

        [Test]
        public void BusinessKeys()
        {
            Assert.AreEqual(2, _domain.Entities["Student"].BusinessKey.Count);
            Assert.AreEqual("FirstName", _domain.Entities["Student"].BusinessKey[0].Source.Name);
            Assert.AreEqual("LastName", _domain.Entities["Student"].BusinessKey[1].Source.Name);
            Assert.AreEqual("ChristianName", _domain.Entities["Student"].BusinessKey[0].Name);
            Assert.AreEqual("LastName", _domain.Entities["Student"].BusinessKey[1].Name);

            Assert.AreEqual(2, _domain.Entities["Car"].BusinessKey.Count);
        }

    }
}
