#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Xml.Serialization;

namespace dnp.DomainModeler.Configuration
{
    [Serializable]
    public abstract class DomainIdentifierDefinitionBase
    {
        private string _sourceObjectName = "";
        private string _name = "";
        private bool _visible;

        protected DomainIdentifierDefinitionBase()
        {
        }

        public DomainIdentifierDefinitionBase(string source, string name, bool visible)
        {
            _sourceObjectName = source;
            _name = name;
            _visible = visible;
        }

        [XmlAttribute]
        public virtual string SourceObjectName
        {
            get { return _sourceObjectName; }
            set { _sourceObjectName = value; }
        }

        [XmlAttribute]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [XmlAttribute]
        public bool Visible
        {
            get { return _visible; }
            set { _visible = value; }
        }
    }
}
