#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Xml.Serialization;

namespace dnp.DomainModeler.Configuration
{
    [Serializable]
    public class EntityDefinition : DomainIdentifierDefinitionBase
    {
        private PropertyDefinitionCollection _properties = new PropertyDefinitionCollection();
        private string _relativeNamespace;
        private BusinessKeyDefinitionCollection _businessKeys =  new BusinessKeyDefinitionCollection();
        private RelationshipDefinitionCollection _relationships = new RelationshipDefinitionCollection();
        private bool _isUpdatable = true;
        private bool _isAbstract;
        private EntityTypeEnum _entityType;
        private string _sourceObjectType = "";

        public EntityDefinition()
        {
        }

        public EntityDefinition(string source, string name, bool visibility)
            : base(source, name, visibility)
        {
        }

        [XmlAttribute]
        public bool IsAbstract
        {
            get { return _isAbstract; }
            set { _isAbstract = value; }
        }

        [XmlAttribute]
        public bool IsUpdatable
        {
            get { return _isUpdatable; }
            set { _isUpdatable = value; }
        }
        public PropertyDefinitionCollection Properties
        {
            get { return _properties; }
            set { _properties = value; }
        }

        [XmlAttribute]
        public string RelativeNamespace
        {
            get { return _relativeNamespace; }
            set { _relativeNamespace = value; }
        }

        public BusinessKeyDefinitionCollection BusinessKeys
        {
            get { return _businessKeys; }
            set { _businessKeys = value; }
        }


        public RelationshipDefinitionCollection Relationships
        {
            get { return _relationships; }
            set { _relationships = value; }
        }

        [XmlAttribute]
        public EntityTypeEnum EntityType
        {
            get { return _entityType; }
            set { _entityType = value; }
        }

        [XmlAttribute]
        public string SourceObjectType
        {
            get { return _sourceObjectType; }
            set { _sourceObjectType = value; }
        }
    }
}