#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.DomainModeler.Configuration;

namespace dnp.ServiceModel
{
    public class ModelDefinition
    {
        private string _clientName = "MyClient";
        private string _modelName = "MyModel";
        private string _copyrightNotice = "Copyright $ClientName$ 2008. All rights reserved.";
        private string _rootPath = "";
        private string _rootNamespace = "";

        private DomainModelDefinition _domainDefinition = new DomainModelDefinition();


        /// <summary>
        /// The name of the client who's domain is being modeled. This information can then be used in copywright notices.
        /// </summary>
        public string ClientName
        {
            get { return _clientName; }
            set { _clientName = value; }
        }

        public string CopyrightNotice
        {
            get { return _copyrightNotice; }
            set { _copyrightNotice = value; }
        }

        /// <summary>
        /// This is the name of the model that is being modeled. This can be used for documentation purposes.
        /// </summary>
        public string ModelName
        {
            get { return _modelName; }
            set { _modelName = value; }
        }

        /// <summary>
        /// The root path for clases to be created in
        /// </summary>
        public string RootPath
        {
            get { return _rootPath; }
            set { _rootPath = value; }
        }

        /// <summary>
        /// This is the namespace that will be used as the suffix for all other namespaces.
        /// </summary>
        public string RootNamespace
        {
            get { return _rootNamespace; }
            set { _rootNamespace = value; }
        }

        public DomainModelDefinition DomainDefinition
        {
            get { return _domainDefinition; }
            set { _domainDefinition = value; }
        }

    }
}