#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.DatabaseExplorer;

namespace dnp.DomainModeler
{
    public abstract class DomainIdentifierBase<P>
    {
        private ISchemaBase _source;
        private string _name = "";
        private bool _visible;
        private P parent;

        protected DomainIdentifierBase(ISchemaBase source, string name, bool visibile, P parent)
        {
            _source = source;
            _name = name;
            _visible = visibile;
            this.parent = parent;
        }

        public abstract Domain Domain
        {
            get;
        }

        public ISchemaBase Source
        {
            get { return _source; }
        }

        public string Name
        {
            get { return _name; }
        }

        public bool Visible
        {
            get { return _visible; }
            internal set{ _visible = value;}
        }

        public P Parent
        {
            get { return parent; }
        }
    }
}