SELECT     c1.TABLE_CATALOG, c1.TABLE_SCHEMA, c1.TABLE_NAME, c.name AS COLUMN_NAME, ex.name AS PROPERTY_NAME, 
                      ex.value AS PROPERTY_DESCRIPTION
FROM         (SELECT     OBJECT_ID(TABLE_SCHEMA + '.' + TABLE_NAME) AS TableID, TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME
                       FROM          INFORMATION_SCHEMA.TABLES WITH (NOLOCK)) AS c1 INNER JOIN
                      sys.extended_properties AS ex WITH (NOLOCK) ON c1.TableID = ex.major_id LEFT OUTER JOIN
                      sys.columns AS c WITH (NOLOCK) ON ex.major_id = c.object_id AND ex.minor_id = c.column_id
WHERE     (NOT (ex.value IS NULL)) AND (ex.name NOT IN ('microsoft_database_tools_support', 'MS_DiagramPane1','MS_DiagramPane2', 'MS_DiagramPaneCount'))
AND ex.Class_Desc='OBJECT_OR_COLUMN'
ORDER BY c1.TABLE_CATALOG, c1.TABLE_SCHEMA, c1.TABLE_NAME