#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Configuration;
using dnp.Framework.Database.DataProvider.Configuration;
using dnp.Framework.Database.InformationSchema;
using MbUnit.Framework;

namespace dnp.Framework.UnitTest.Database.InformationSchema
{
    [TestFixture]
    public class SQLServerProviderTest
    {
        [Test]
        public void RetrieveColumnSchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            ColumnSchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveColumnSchema();

            Assert.IsTrue(items.Count>0,"No columns found");
        }

        [Test]
        public void RetrieveConstraintSchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            ConstraintSchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveConstraintSchema();

            Assert.IsTrue(items.Count > 0, "No contraints found");
        }

        [Test]
        public void RetrieveForeignConstraintSchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            ForeignConstraintSchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveForeignConstraintSchema();

            Assert.IsTrue(items.Count > 0, "No foreign contraints found");
        }

        [Test]
        public void RetrieveIndexSchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            IndexSchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveIndexSchema();

            Assert.IsTrue(items.Count > 0, "No indexes found");
        }

        [Test]
        public void RetrieveViewColumnSchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            ColumnSchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveViewColumnSchema();

            Assert.IsTrue(items.Count > 0, "No views found");
        }

        [Test]
        public void RetrieveExtendedPropertySchema()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            ExtendedPropertySchemaCollection items;
            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            items = sqlProvider.RetrieveExtendedPropertySchema();

            Assert.IsTrue(items.Count > 0, "No Extended properties found");
        }

        [Test]
        public void DatabaseName()
        {
            DatabaseDefinitions dataProviderConfig = ConfigurationManager.RetrieveSection<DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            SQLServerProvider sqlProvider = new SQLServerProvider(dataProviderConfig.Databases["ReferenceSchema"].ConnectionString);

            ColumnSchemaCollection items;
            items = sqlProvider.RetrieveColumnSchema();

            Assert.AreEqual("ReferenceSchema", sqlProvider.DatabaseName);
        }
    }
}