#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Collections.Generic;
using dnp.Framework.Scripting;

namespace dnp.Framework.Collections
{
    /// <summary>
    /// This collection class is used to store objects of any type. However, it will also
    /// allow you to retrieve obects of a specific type. This collection can be useful
    /// in scripting.
    /// </summary>
    public class ObjectListEx : List<object>
    {
        public ObjectListEx FilterByType(Type type)
        {
            ObjectListEx foundObjects = new ObjectListEx();
            foreach(object o in this)
                if(o is Type)
                    foundObjects.Add(o);

            return foundObjects;
        }

        public void AddRange(System.Collections.IEnumerable collection)
        {
            foreach (object entity in collection)
                this.Add(entity);
        }

        public string ToString(string expression, string joiner)
        {
            return new TextList(this, expression).ToString(joiner);
        }

    }
}
