#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Data;
using System.Text;
using dnp.Framework.Reflection;

namespace dnp.Framework.Database
{
    /// <summary>
    /// This class provides functionality that is lacking in the MS DataAccess block
    /// </summary>
    public class DataAccessExtension
    {
        public static T DeserializeObject<T>(IDataReader dr)
        {
            using (dr)
            {
                StringBuilder xmlBuilder = new StringBuilder();

                // Retrieve result as XML
                while (dr.Read())
                {
                    xmlBuilder.Append(dr[0]);
                }

                if (xmlBuilder.Length > 0)
                    // Convert the XML into its type
                    return Serializer.Deserialize<T>(xmlBuilder.ToString());
                else
                    return default(T);
            }
        }

        public static object DatabaseValue(object value)
        {
            if (value == null)
                return DBNull.Value;
            else
                return value;
        }
    }
}