#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;

namespace dnp.Framework.Database.DataProvider
{
    public class DataProviderFactory
    {
        private static Configuration.DatabaseDefinitions _config;

        public static IDataProvider GetDataProvider(string databaseName)
        {
            if (_config == null)
                _config = dnp.Framework.Configuration.ConfigurationManager.RetrieveSection<Configuration.DatabaseDefinitions>("dnp.Framework/DatabaseDefinitions");

            Configuration.Database database = _config.Databases[databaseName];
            if (database == null)
                throw new ArgumentException("Unknown database: " + databaseName);

            IDataProvider provider = null;
            provider = ((IDataProvider)dnp.Framework.Reflection.Assembly.CreateInstanceFromString(_config.DataProviders[database.DataProvider].Assembly));
            provider.DatabaseName = database.Name;
            provider.ConnectionString = database.ConnectionString;

            return provider;
        }

    }
}
