#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System.Data;

namespace dnp.Framework.Database.DataProvider
{
    public interface IDataProvider
    {
        #region Properties

        string DatabaseName { get; set; }
        string ConnectionString { get; set; }
        string ErrorMessage { get; set; }

        #endregion

        #region Methods

        IDataReader Execute(IDbCommand cmd);
        IDataReader Execute(string storedProcedure);
        object ExecuteScalar(IDbCommand cmd);
        int ExecuteNonQuery(IDbCommand cmd);

        IDbCommand CreateCommand();
        IDataParameter CreateParameter();
        IDataParameter CreateParameter(IDbCommand command, string parameterName, DbType dbType);
        T DeserializeObject<T>(IDbCommand command);

        #endregion
    }
}