#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.InformationSchema;

namespace dnp.Framework.Database.DatabaseExplorer
{
    public class ForeignKeyConstraint : Constraint
    {
        private Constraint _primaryKey;

        public ForeignKeyConstraint(Table parent, ForeignConstraintSchemaCollection schema)
        {
            base.Parent = parent;
            
            base.Database = this.Parent.Database;
            base.Name = schema[0].ConstraintName;
            this.ConstraintSchema = schema[0];

            // Now cycle through each column schema adding it to the columns collection
            foreach (ForeignConstraintSchema constraintSchema in schema)
            {
                this.ProcessConstraint(constraintSchema);

                // Now locate the primary key constraint for the foreign key constraint
                // nb: Assume that all other constraints have been processed already!

                _primaryKey =
                    this.Database.Tables[constraintSchema.UniqueSchema + "." + constraintSchema.UniqueTableName].PrimaryKey;
            }
        }

        public Constraint PrimaryKey
        {
            get { return _primaryKey; }
        }
    }
}
