#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;

namespace dnp.Framework.Database.DatabaseExplorer
{
    public interface IColumn : ISchemaBase
    {
        bool IsIdentity { get; }

        /// <summary>
        /// The position number within the table. This number is 1 based.
        /// </summary>
        int OrdinalPosition { get; }

        string ColumnDefault { get; }

        bool IsNullable { get; }

        bool IsComputed { get; }

        string DataType { get; }

        Type DotNetType { get;}

        int? CharacterMaximumLength { get; }

        int? NumericPrecision { get; }

        int? NumericScale { get; }

        int? DateTimePrecision { get; }

        string CollationName { get; }

        bool InUnquieIndex { get;}
        bool InPrimaryKey { get;}
        bool InForeignKey { get;}
        bool HasIndex { get;}

    }
}