#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.InformationSchema;

namespace dnp.Framework.Database.DatabaseExplorer
{
    public class Index : SchemaBase
    {
        private TableColumnCollection _columns = new TableColumnCollection();
        private IndexSchemaCollection _indexSchema;

       public Index(Table parent, IndexSchemaCollection schema):base(schema[0].ConstraintName, parent,parent.Database)
        {
            _indexSchema = schema;

            // Now cycle through each column schema adding it to the columns collection
            foreach (IndexSchema indexSchema in schema)
            {
                TableColumn c = this.Database.Tables[indexSchema.TableSchema + "." + indexSchema.TableName].Columns[indexSchema.ColumnName];

                this.Columns.Add(c);
            }
        }

        public new Table Parent
        {
            get { return base.Parent as Table; }
        }
        public int FillFactor
        {
            get { return _indexSchema[0].FillFactor; }
        }

        public bool IsUnique
        {
            get { return _indexSchema[0].IndexType == "UNIQUE"; }
        }

        public bool IsClustered
        {
            get { return _indexSchema[0].IsClustered; }
        }

        public bool IsDisabled
        {
            get { return _indexSchema[0].IsDisabled; }
        }
        public bool IsPrimaryKey
        {
            get { return this.Parent.PrimaryKey.Name == this.Name; }
        }

        public TableColumnCollection Columns
        {
            get { return this._columns; }
        }
    }
}
