﻿#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty – Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.InformationSchema;


namespace dnp.Framework.Database.DatabaseExplorer
{
    public class RoutineParameterColumn : Column
    {
        public RoutineParameterColumn(Routine parent, RoutineParameterColumnSchema columnSchema)
            : base(parent, parent.Database, columnSchema)
        {
        }

        public new Routine Parent
        {
            get { return (Routine)base.Parent; }
            protected set { base.Parent = value; }
        }

        public override bool InUnquieIndex
        {
            get { return false; }
        }

        public override bool InPrimaryKey
        {
            get { return false; }
        }

        public override bool InForeignKey
        {
            get { return false; }
        }

        public override bool HasIndex
        {
            get { return false; }
        }

        /// <summary>
        /// Converts the SQL paramter name into a name that can be used in an entity
        /// </summary>
        public string PropertyName
        {
            get { return this.Name.Substring(1); }
        }
        public RoutineParameterDirection ParameterType
        {
            get { return ((RoutineParameterColumnSchema)this.ColumnSchema).Direction; }
        }
    }
}