#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.InformationSchema;

namespace dnp.Framework.Database.DatabaseExplorer
{

    public class View : SchemaBase
    {
        private ViewColumnCollection _columns;
        private string _schema;

        public View(Database parent, ColumnSchemaCollection columns)
            : base(columns[0].TableName, parent, parent)
        {
            _columns = new ViewColumnCollection(this, columns);

            // Populate base class
            _schema = columns[0].TableSchema;
        }

        public new Database Parent
        {
            get { return base.Parent as Database; }
        }
        public string Schema
        {
            get { return _schema; }
        }

        public ViewColumnCollection Columns
        {
            get { return this._columns; }
        }

        public override string FullName
        {
            get { return this.Schema + "." + this.Name; }
        }

        public string SafeFullName
        {
            get { return string.Format("[{0}].[{1}]", this.Schema, this.Name); }
        }

        public string Text
        {
            get { return this.Parent.Provider.RetrieveText(this); }
        }
    }
}