#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;

namespace dnp.Framework.Database.InformationSchema
{
    public class ColumnSchema
    {
        private string _tableCatalog = "";
        private string _tableSchema = "";
        private string _tableName = "";
        private string _columnName = "";
        private int _ordinalPosition;
        private string columnDefault;
        private bool isNullable;
        private string dataType = "";
        private int? _characterMaximumLength;
        private int? _numericPrecision;
        private int? _numericScale;
        private int? _dateTimePrecision;
        private string _collationName;
        private bool _isIdentity;
        private bool _isTable;
        private bool _isComputed;
        private int _size;

        public bool IsIdentity
        {
            get { return _isIdentity; }
            set { _isIdentity = value; }
        }

        public string TableCatalog
        {
            get { return _tableCatalog; }
            set { _tableCatalog = value; }
        }

        public string TableSchema
        {
            get { return _tableSchema; }
            set { _tableSchema = value; }
        }

        public string TableName
        {
            get { return _tableName; }
            set { _tableName = value; }
        }

        public string ColumnName
        {
            get { return _columnName; }
            set { _columnName = value; }
        }

        public int OrdinalPosition
        {
            get { return _ordinalPosition; }
            set { _ordinalPosition = value; }
        }

        public string ColumnDefault
        {
            get { return columnDefault; }
            set { columnDefault = value; }
        }

        public bool IsNullable
        {
            get { return isNullable; }
            set { isNullable = value; }
        }

        public string DataType
        {
            get { return dataType; }
            set { dataType = value; }
        }

        public int? CharacterMaximumLength
        {
            get { return _characterMaximumLength; }
            set { _characterMaximumLength = value; }
        }

        public int? NumericPrecision
        {
            get { return _numericPrecision; }
            set { _numericPrecision = value; }
        }

        public int? NumericScale
        {
            get { return _numericScale; }
            set { _numericScale = value; }
        }

        public int? DateTimePrecision
        {
            get { return _dateTimePrecision; }
            set { _dateTimePrecision = value; }
        }
        /// <summary>
        /// The represents the size in bytes the column takes
        /// </summary>
        public int Size
        {
            get { return _size; }
            set { _size = value; }
        }

        public string CollationName
        {
            get { return _collationName; }
            set { _collationName = value; }
        }

        public bool IsTable
        {
            get { return this._isTable; }
            set { this._isTable = value; }
        }

        public bool IsComputed
        {
            get { return this._isComputed; }
            set { this._isComputed = value; }
        }
    }
}