#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Data;
using dnp.Framework.Database.DatabaseExplorer;

namespace dnp.Framework.Database.InformationSchema
{
    public interface IInformationSchemaProvider
    {
        string ConnectionString { get; set; }

        ColumnSchemaCollection RetrieveColumnSchema();
        ConstraintSchemaCollection RetrieveConstraintSchema();
        ForeignConstraintSchemaCollection RetrieveForeignConstraintSchema();
        IndexSchemaCollection RetrieveIndexSchema();
        ColumnSchemaCollection RetrieveViewColumnSchema();
        ColumnSchemaCollection RetrieveRoutineColumnSchema();
        RoutineParameterColumnSchemaCollection RetrieveRoutineParametersSchema();
        ExtendedPropertySchemaCollection RetrieveExtendedPropertySchema();

        string DatabaseName { get;}

        // Database specific converters
        Type DotNetType(string dataType);
        int Size(ColumnSchema column);
        string SQLType(ColumnSchema column);
        string RetrieveText(SchemaBase schema);


        // Methods
        IDataReader ExecuteSQL(string sqlStatement);
    }
}