#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
namespace dnp.Framework.IO
{
    public class EmbeddedResources
    {
        private static System.IO.Stream GetResourceStream(string resourceName, System.Reflection.Assembly callingAssembly)
        {
            string strFullResourceName = "";
            foreach (string r in callingAssembly.GetManifestResourceNames())
            {
                if (r.EndsWith(resourceName))
                {
                    strFullResourceName = r;
                    break;
                }
            }

            if (string.IsNullOrEmpty(strFullResourceName))
                throw new System.ArgumentException("Unable to locate resource: " + resourceName);

            //  The PDA versions of assemblies report an incorrect namespace
            return callingAssembly.GetManifestResourceStream(strFullResourceName);
        }

        public static string GetResourceString(string resourceName, System.Reflection.Assembly assembly)
        {
            System.IO.StreamReader objStream;
            string strText = "";
            using (objStream = new System.IO.StreamReader(GetResourceStream(resourceName, assembly)))
            {
                strText = objStream.ReadToEnd();
            }

            return strText;
        }
        public static string GetResourceString(string resourceName)
        {
            System.Reflection.Assembly assembly = System.Reflection.Assembly.GetCallingAssembly();

            return GetResourceString(resourceName, assembly);
        }
    }
}
