#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;

namespace dnp.Framework.Reflection
{
    public class Assembly
    {

        public static object CreateInstance(string assemblyName, string className)
        {
            if (assemblyName.Length == 0)
            {
                throw new ApplicationException("assemblyName not defined.");
            }
            if (className.Length == 0)
            {
                throw new ApplicationException("className not defined.");
            }
            return Activator.CreateInstance(assemblyName, className).Unwrap();
        }
        public static object CreateInstanceFromQualifiedName(string qualifiedName)
        {
            return CreateInstance(System.Type.GetType(qualifiedName));
        }
        public static object CreateInstance(string className)
        {
            return CreateInstance(System.Reflection.Assembly.GetExecutingAssembly().GetType(className));
        }

        public static object CreateInstanceFromString(string assemblyDetails)
        {
            string strAssemblyName = "";
            string strClassName = "";
            if (assemblyDetails.Length != 0)
            {
                strAssemblyName = assemblyDetails.Split(',').GetValue(0).ToString().Trim();
                strClassName = assemblyDetails.Split(',').GetValue(1).ToString().Trim();
            }
            return CreateInstance(strAssemblyName, strClassName);
        }

        public static object CreateInstance(System.Type classType)
        {
            return System.Activator.CreateInstance(classType);
        }
    }
}
