#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System.Collections.Generic;

namespace dnp.Framework.Scripting
{
    public class TextList : List<string>
    {
        public TextList()
        {
        }

        public TextList(IEnumerable<string> collection)
            : base(collection)
        {
        }

        public TextList(System.Collections.IEnumerable collection, string expression)
        {
            this.AddRange(collection, expression);
        }
        public void AddRange(System.Collections.IEnumerable collection, string expression)
        {
            foreach (object entity in collection)
                this.Add(entity, expression);
        }

        public void Add(object entity, string expression)
        {
             this.Add(Naming.EvaluateNamingExpression(expression, entity));
        }
        public string ToString(string seperator)
        {
            return string.Join(seperator, this.ToArray());
        }
    }
}
