#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.ServiceModel.Configuration;
using dnp.UnitTestEx;
using MbUnit.Framework;

namespace dnp.ServiceModel.Test
{
    [TestFixture]
    public class BusinessLayerTest
    {
        private dnpModel _model;
        private BusinessLayer _businessLayer;

        [TestFixtureSetUp]
        public void InitializeTest()
        {
            ServiceModelDefinition expectedModel = Testing.IO.Serializer.RetrieveResourceObject<ServiceModelDefinition>("dnpModelConfiguration.xml");

            _model = new dnpModel(expectedModel);
            _businessLayer = _model.BusinessLayer;

        }

        [Test]
        public void BusinessServiceFeatures()
        {
            Assert.IsNotNull(_businessLayer.Features);
        }

        [Test]
        public void BusinessServices()
        {
            Assert.IsNotNull(_businessLayer.BusinessServices);
            Assert.AreEqual(17, _businessLayer.BusinessServices.Count);
        }

        [Test]
        public void Domain()
        {
            Assert.IsNotNull(_businessLayer.Domain);
        }

        [Test]
        public void Model()
        {
            Assert.IsNotNull(_businessLayer.Model);
        }

        [Test]
        public void DomainLayerNamespace()
        {
            Assert.AreEqual("DotNetProfessional.ReferenceSchema.Business.Entities", _businessLayer.DomainLayerNamespace);
            Assert.AreEqual("DotNetProfessional.ReferenceSchema.Business.Services", _businessLayer.ServiceLayerNamespace);
            Assert.AreEqual("Business.Entities", _businessLayer.RelativeDomainLayerNamespace);
            Assert.AreEqual("Business.Services", _businessLayer.RelativeServiceLayerNamespace);


        }
    }
}
