﻿#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty – Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.ServiceModel.Configuration;
using dnp.UnitTestEx;
using MbUnit.Framework;

namespace dnp.ServiceModel.Test
{
    [TestFixture]
    public class BusinessServiceFeaturesTest
	{
        private dnpModel _model;
        private BusinessLayer _businessLayer;

        [TestFixtureSetUp]
        public void InitializeTest()
        {
            ServiceModelDefinition expectedModel = Testing.IO.Serializer.RetrieveResourceObject<ServiceModelDefinition>("dnpModelConfiguration.xml");

            _model = new dnpModel(expectedModel);
            _businessLayer = _model.BusinessLayer;

        }

        [Test]
        public void Features()
        {
            Assert.AreEqual(true, _businessLayer.Features.SupportWCF);
            Assert.AreEqual(3.0, _businessLayer.Features.TargetCLRVersion);
            Assert.AreEqual("SQL2005", _businessLayer.Features.TargetDatabase);
        }


	}
}
