#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.ServiceModel.Configuration;
using dnp.UnitTestEx;
using MbUnit.Framework;

namespace dnp.ServiceModel.Test
{
    [TestFixture]
    public class dnpModelTest
    {
        private dnpModel _model;

        [TestFixtureSetUp]
        public void InitializeTest()
        {
            ServiceModelDefinition expectedModel = Testing.IO.Serializer.RetrieveResourceObject<ServiceModelDefinition>("dnpModelConfiguration.xml");

            
            _model = new dnpModel(expectedModel);
            //string path = Path.GetDirectoryName(Path.GetFullPath(new Uri(typeof(dnpModelTest).Assembly.CodeBase).LocalPath));
            //_model = new dnpModel(@"H:\Clients\dotNetProfessional\Dev\Merlot\emarketing\eMarketing.Model.xml");
        }

        [Test]
        public void Initialize()
        {
            // Now assert basic information about the initialization
            Assert.AreEqual(17, _model.BusinessLayer.BusinessServices.Count, "model.BusinessLayer.BusinessServices.Count");
        }

        [Test]
        public void Version()
        {
            Assert.AreEqual("1.0.0", _model.Version);
        }

        [Test]
        public void Definition()
        {
            Assert.IsNotNull(_model.Definition);
        }

        [Test]
        public void BusinessLayer()
        {
            Assert.IsNotNull(_model.BusinessLayer);
        }
    }
}