#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.ServiceModel.Configuration;

namespace dnp.ServiceModel
{
    public class BusinessLayerFeatures
    {
        private BusinessLayerFeatureDefinition _definition;
        private dnpModel _model;

        public BusinessLayerFeatures(BusinessLayerFeatureDefinition definition, dnpModel model)
        {
            _definition = definition;
            _model = model;
        }

        public dnpModel Model
        {
            get { return _model; }
        }

        public BusinessLayer Parent
        {
            get { return this.Model.BusinessLayer; }
        }

        public bool SupportWCF
        {
            get { return _definition.SupportWCF; }
        }

        public string TargetDatabase
        {
            get { return _definition.TargetDatabase; }
        }

        public double TargetCLRVersion
        {
            get { return _definition.TargetCLRVersion; }
        }

        public bool SupportTimeZone
        {
            get{ return _definition.SupportTimeZone;}
        }

        public bool AddIsValidToEntity
        {
            get { return _definition.AddIsValidToEntity; }
        }
    }
}