#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
namespace dnp.ServiceModel.Configuration
{
    public class BusinessLayerDefinition
    {
        private BusinessServiceDefinitionCollection _businessServiceDefinitions = new BusinessServiceDefinitionCollection();
        private MetaDataDefinition _MetaData = new MetaDataDefinition();
        private BusinessLayerFeatureDefinition _features = new BusinessLayerFeatureDefinition();
        private string _relativeServiceLayerNamespace = "";
        private string _relativeDomainLayerNamespace = "";

        public MetaDataDefinition MetaData
        {
            get { return _MetaData; }
            set { _MetaData = value; }
        }

        /// <summary>
        /// Relative namespace from the root for the domain
        /// </summary>
        /// <example>
        /// Business.Entities
        /// </example>
        public string RelativeDomainLayerNamespace
        {
            get { return _relativeDomainLayerNamespace; }
            set { _relativeDomainLayerNamespace = value; }
        }

        /// <summary>
        /// Relative namespace from the root for the service layer
        /// </summary>
        /// <example>
        /// Business.Services
        /// </example>
        public string RelativeServiceLayerNamespace
        {
            get { return _relativeServiceLayerNamespace; }
            set { _relativeServiceLayerNamespace = value; }
        }

        public BusinessServiceDefinitionCollection BusinessServiceDefinitions
        {
            get { return _businessServiceDefinitions; }
            set { _businessServiceDefinitions = value; }
        }

        public BusinessLayerFeatureDefinition Features
        {
            get { return _features; }
            set { _features = value; }
        }
    }
}