#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System;
using System.Xml.Serialization;

namespace dnp.ServiceModel.Configuration
{
    [Serializable]
    public class ExposedEntityDefinition
    {
        private bool _includeExists = true;
        private bool _includeHardDelete = true;
        private bool _includeRelatedEntities = true;
        private bool _includeRetrieveMultiple = true;
        private bool _includeRetrieveSingle = true;
        private bool _includeSoftDelete = true;
        private bool _includeRetrieveRelationship = true;
        private string _sourceObjectName = "";
        private ServiceReturnTypeDefinition _returnType;

        public ServiceReturnTypeDefinition ReturnType
        {
            get { return _returnType; }
            set { _returnType = value; }
        }

        [XmlAttribute]
        public string SourceObjectName
        {
            get { return _sourceObjectName; }
            set { _sourceObjectName = value; }
        }

        [XmlAttribute]
        public bool IncludeRetrieveMultiple
        {
            get { return _includeRetrieveMultiple; }
            set { _includeRetrieveMultiple = value; }
        }

        [XmlAttribute]
        public bool IncludeSoftDelete
        {
            get { return _includeSoftDelete; }
            set { _includeSoftDelete = value; }
        }

        [XmlAttribute]
        public bool IncludeHardDelete
        {
            get { return _includeHardDelete; }
            set { _includeHardDelete = value; }
        }

        [XmlAttribute]
        public bool IncludeRelatedEntities
        {
            get { return _includeRelatedEntities; }
            set { _includeRelatedEntities = value; }
        }

        [XmlAttribute]
        public bool IncludeStore { get; set; }

        [XmlAttribute]
        public bool IncludeRetrieveSingle
        {
            get { return _includeRetrieveSingle; }
            set { _includeRetrieveSingle = value; }
        }

        [XmlAttribute]
        public bool IncludeRetrieveRelationship
        {
            get { return _includeRetrieveRelationship; }
            set { _includeRetrieveRelationship = value; }
        }

        [XmlAttribute]
        public bool IncludeExists
        {
            get { return _includeExists; }
            set { _includeExists = value; }
        }
    }
}