#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion

using System.Xml.Serialization;

namespace dnp.ServiceModel.Configuration
{
    public class ServiceMethodDefinition
    {
        private string _name = "";
        private string _storedProcedureName = "";
        private string _sourceEntityName = "";
        private ServiceFeatureEnum _serviceFeature;
        private ServiceReturnTypeDefinition _returnType;
        private ServiceMethodTypeEnum _serviceMethodType;

        private ParameterMapDefinitionCollection _storedProcedureMapping = new ParameterMapDefinitionCollection();
        private ServiceMethodParameterDefinitionCollection _parameters = new ServiceMethodParameterDefinitionCollection();
        private ServiceReturnTypePropertyMapDefinitionCollection _returnTypeParamterMapping = new ServiceReturnTypePropertyMapDefinitionCollection();

        public ServiceMethodDefinition()
        {
        }

        public ServiceMethodDefinition(string name, ServiceFeatureEnum serviceFeature, string sourceEntityName, string storedProcedureName, ServiceMethodTypeEnum serviceMethodType)
        {
            _name = name;
            _serviceFeature = serviceFeature;
            _sourceEntityName = sourceEntityName;
            _storedProcedureName = storedProcedureName;
            _serviceMethodType = serviceMethodType;
        }


        [XmlAttribute]
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        [XmlAttribute]
        public string StoredProcedureName
        {
            get { return _storedProcedureName; }
            set { _storedProcedureName = value; }
        }

        [XmlAttribute]
        public ServiceFeatureEnum ServiceFeature
        {
            get { return _serviceFeature; }
            set { _serviceFeature = value; }
        }

        [XmlAttribute]
        public ServiceMethodTypeEnum ServiceMethodType
        {
            get { return _serviceMethodType; }
            set { _serviceMethodType = value; }
        }

        public string SourceEntityName
        {
            get { return _sourceEntityName; }
            set { _sourceEntityName = value; }
        }

        public ServiceReturnTypeDefinition ReturnType
        {
            get { return _returnType; }
            set { _returnType = value; }
        }

        public ParameterMapDefinitionCollection StoredProcedureMapping
        {
            get { return _storedProcedureMapping; }
            set { _storedProcedureMapping = value; }
        }

        public ServiceMethodParameterDefinitionCollection Parameters
        {
            get { return _parameters; }
            set { _parameters = value; }
        }

        public ServiceReturnTypePropertyMapDefinitionCollection ReturnTypeParamterMapping
        {
            get { return _returnTypeParamterMapping; }
            set { _returnTypeParamterMapping = value; }
        }
    }
}
