﻿#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty – Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using System.Xml.Serialization;

namespace dnp.ServiceModel.Configuration
{
    public class ServiceReturnTypePropertyMapDefinition
    {
        private string _propertyMapping;
        private string _fieldName;
        private string _dotNetType;
        private bool _isNullable;
        private bool _isIntrinsicType;

        [XmlAttribute]
        public string PropertyMapping
        {
            get { return _propertyMapping; }
            set { _propertyMapping = value; }
        }

        [XmlAttribute]
        public string FieldName
        {
            get { return _fieldName; }
            set { _fieldName = value; }
        }

        [XmlAttribute]
        public string DotNetType
        {
            get { return _dotNetType; }
            set { _dotNetType = value; }
        }

        [XmlAttribute]
        public bool IsNullable
        {
            get { return _isNullable; }
            set { _isNullable = value; }
        }

        /// <summary>
        /// Is the DotNetType a simple instrinsic type or is it a custom type
        /// </summary>
        [XmlAttribute]
        public bool IsIntrinsicType
        {
            get { return _isIntrinsicType; }
            set { _isIntrinsicType = value; }
        }
    }
}
