#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.DomainModeler;

namespace dnp.ServiceModel
{
    public class PropertyEx
    {
        private string _sourceName;
        private Property _property;
        private Property _mappedProperty;
        private string _alias;

        public PropertyEx(Property property, Property mappedProperty, string mappedAlias)
        {
            _sourceName = property.Source.Name;
            _property = property;
            _mappedProperty = mappedProperty;
            _alias = mappedAlias;
        }

        public string SourceName
        {
            get { return _sourceName; }
        }

        public Property Property
        {
            get { return _property; }
        }

        /// <summary>
        /// Determines if the property has been mapped or if it has the same definition in the MappedProperty as
        /// is in the Property, property
        /// </summary>
        public bool IsMapped
        {
            get { return this.Property.Source.Name != this.MappedProperty.Source.Name; }
        }
        public Property MappedProperty
        {
            get { return _mappedProperty; }
        }

        public string Alias
        {
            get { return _alias; }
            set { _alias = value;}
        }
        public string RelatedPropertyPrimaryKey
        {
            get { return this.MappedProperty.Parent.PrimaryKey.Properties[0].Source.Name; }
        }
    }
}
