#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Collections;

namespace dnp.ServiceModel
{
    public class PropertyExCollection : MultiKeyedCollection<PropertyEx>
    {
        public PropertyExCollection()
            : base("SourceName")
        {
        }

        /// <summary>
        /// Returns a filtered list based on serveral common criteria
        /// </summary>
        /// <param name="filter">Flags based filter</param>
        /// <returns>instances that match filter</returns>
        public PropertyExCollection Filter(PropertyExFilterEnum filter)
        {
            PropertyExCollection filteredCollection = new PropertyExCollection();
            foreach (PropertyEx p in this)
            {
                if (PropertyExFilterEnum.IsComputed == (PropertyExFilterEnum.IsComputed & filter))
                    if (p.Property.IsComputed)
                        filteredCollection.Add(p);

                if (PropertyExFilterEnum.NotComputed == (PropertyExFilterEnum.NotComputed & filter))
                    if (!p.Property.IsComputed)
                        filteredCollection.Add(p);

                if (PropertyExFilterEnum.IsMapped == (PropertyExFilterEnum.IsMapped & filter))
                    if (p.IsMapped)
                        if(!filteredCollection.Contains(p)) filteredCollection.Add(p);

                if (PropertyExFilterEnum.NotMapped == (PropertyExFilterEnum.NotMapped & filter))
                    if (!p.IsMapped)
                        if (!filteredCollection.Contains(p)) filteredCollection.Add(p);
            }
            return filteredCollection;
        }
    }
}