﻿#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty – Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.DomainModeler;

namespace dnp.ServiceModel
{
    public class ServiceMethodParameter
    {
        private readonly string _name = "";
        private readonly string _dotNetType;
        private readonly string _relativeNamespace = "";
        
        public ServiceMethodParameter(string name, string typeNamespace, string dotNetType)
        {
            _dotNetType = dotNetType;
            _name = name;
            _relativeNamespace = typeNamespace;
        }

        public string Name
        {
            get { return _name; }
        }

        public string DotNetType
        {
            get { return _dotNetType; }
        }

        public string RelativeNamespace
        {
            get { return _relativeNamespace; }
        }

        public string RelativeName
        {
            get { return Model.FixNamespace(this.RelativeNamespace + "." + this.DotNetType); }
        }
    }
}
