#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.Framework.Database.DatabaseExplorer;

namespace dnp.ServiceModel
{
    public class ServiceMethodRelationship
    {
        private string _methodName = "";
        private RelationshipTypeEnum _relationshipType;
        private readonly ServiceMethodParameterCollection _parameterMapping = new ServiceMethodParameterCollection();
        private string _serviceName = "";


        public ServiceMethodRelationship(string serviceName, string methodName, RelationshipTypeEnum relationshipType)
        {
            _methodName = methodName;
            _relationshipType = relationshipType;
            _serviceName = serviceName;
        }

        public string ServiceName
        {
            get { return _serviceName; }
            set { _serviceName = value; }
        }

        public string MethodName
        {
            get { return _methodName; }
            set { _methodName = value; }
        }

        public RelationshipTypeEnum RelationshipType
        {
            get { return _relationshipType; }
            set { _relationshipType = value; }
        }

        public ServiceMethodParameterCollection ParameterMapping
        {
            get { return _parameterMapping; }
        }
    }
}
