#region License
// (c) Garry McGlennon 2009
// 
// This project is made available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// 
// View the project and the latest code at http://dnpframework.codeplex.com/
// 
// All other rights reserved.
// 
// blog: www.dotNetProfessional.com/blog/
#endregion
using dnp.DomainModeler;
using dnp.Framework.Reflection;
using dnp.ServiceModel.Configuration;

namespace dnp.ServiceModel
{
    public class dnpModel : Model
    {
        private BusinessLayer _businessLayer;

        public dnpModel(string modelDefinitionFileName)
        {
            // Load the definition file.
            ServiceModelDefinition definition =
                Serializer.DeserializeFromFile<ServiceModelDefinition>(modelDefinitionFileName);

            Initialize(definition);
        }

        public dnpModel(ServiceModelDefinition definition) : base(definition)
        {
           this.Initialize(definition);
        }

        protected void Initialize(ServiceModelDefinition definition)
        {
            base.Initialize(definition);
            _businessLayer = new BusinessLayer(this);

            // Work out if the ModelName and Client Name was set in the Domain or Model config
            if (string.IsNullOrEmpty(definition.DomainDefinition.ClientName) && !string.IsNullOrEmpty(definition.ClientName))
                definition.DomainDefinition.ClientName = definition.ClientName;

            if (string.IsNullOrEmpty(definition.DomainDefinition.ModelName) && !string.IsNullOrEmpty(definition.ModelName))
                definition.DomainDefinition.ModelName = definition.ModelName;

        }


        public ServiceModelDefinition Definition
        {
            get { return _definition as ServiceModelDefinition; }
        }

        public BusinessLayer BusinessLayer
        {
            get { return _businessLayer; }
        }
    }
}